## mingw-w64-qgis-3.44.1-1.src.tar.zst

=== CMakeLists.txt ===
#############################################################
# CMake settings
cmake_minimum_required(VERSION 3.22.0)
set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_AUTORCC ON)
# set path to additional CMake modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
# POLICIES
if("${CMAKE_VERSION}" VERSION_GREATER_EQUAL "3.27")
  # include(Dart) still used, as is the "Experimental" target
  cmake_policy(SET CMP0145 OLD)
endif()
if("${CMAKE_VERSION}" VERSION_GREATER_EQUAL "3.31")
  cmake_policy(SET CMP0177 NEW)
endif()

# don't relink it only the shared object changes
set(CMAKE_LINK_DEPENDS_NO_SHARED ON)

option (WITH_PYTHON "Determines whether Python support should be built (disabling it will in particular disable processing)" ON)
set(WITH_BINDINGS ${WITH_PYTHON} CACHE BOOL "Determines whether Python bindings should be built")

set (WITH_3D TRUE CACHE BOOL "Determines whether QGIS 3D library should be built")
set (WITH_QGIS_PROCESS TRUE CACHE BOOL "Determines whether the standalone \"qgis_process\" tool should be built")
set (WITH_DESKTOP TRUE CACHE BOOL "Determines whether QGIS desktop should be built")
set (WITH_GUI TRUE CACHE BOOL "Determines whether QGIS GUI library should be built")
set(WITH_VCPKG FALSE CACHE BOOL "Use the vcpkg submodule for dependency management.")

set(SDK_PATH "" CACHE STRING "Build with VCPKG SDK")

if(NOT SDK_PATH STREQUAL "")
  message(STATUS "Building with SDK -- ${SDK_PATH}")
  set(CMAKE_TOOLCHAIN_FILE "${SDK_PATH}/scripts/buildsystems/vcpkg.cmake")
  set(VCPKG_INSTALL_PREFIX "${SDK_PATH}/installed")
  if(APPLE AND NOT VCPKG_TARGET_TRIPLET)
    message(FATAL_ERROR "VCPKG_TARGET_TRIPLET not set (set it to arm64-osx-dynamic-release or x64-osx-dynamic-release")
  endif()
  set(WITH_VCPKG ON)
elseif(WITH_VCPKG)
  message(STATUS "Building local dependencies with VCPKG --")
  set(VCPKG_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/vcpkg_installed")
  include(VcpkgToolchain)
else()
  message(STATUS "Building with system libraries --")
endif()


if(WITH_VCPKG)
  if(WIN32)
    list(APPEND CMAKE_PROGRAM_PATH "${VCPKG_INSTALL_PREFIX}/${VCPKG_TARGET_TRIPLET}/tools/python3/Scripts/")
  else()
    list(APPEND CMAKE_PROGRAM_PATH "${VCPKG_INSTALL_PREFIX}/${VCPKG_TARGET_TRIPLET}/bin")
  endif()
  set(PREFER_INTERNAL_LIBS FALSE)
else()
  set(PREFER_INTERNAL_LIBS TRUE)
endif()

#############################################################
# Project and version
set(CPACK_PACKAGE_VERSION_MAJOR "3")
set(CPACK_PACKAGE_VERSION_MINOR "44")
set(CPACK_PACKAGE_VERSION_PATCH "1")
set(COMPLETE_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set(RELEASE_NAME "Solothurn")
project(qgis VERSION ${COMPLETE_VERSION})

if (APPLE)
  set(QGIS_APP_NAME "QGIS")
else()
  set(QGIS_APP_NAME "qgis")
endif()

# Note the version no is Mmmpp for Major/minor/patch, 0-padded, thus '10100' for 1.1.0
math(EXPR QGIS_VERSION_INT "${CPACK_PACKAGE_VERSION_MAJOR}*10000+${CPACK_PACKAGE_VERSION_MINOR}*100+${CPACK_PACKAGE_VERSION_PATCH}")
message(STATUS "QGIS version: ${COMPLETE_VERSION} ${RELEASE_NAME} (${QGIS_VERSION_INT})")

set (ENABLE_LOCAL_BUILD_SHORTCUTS FALSE CACHE BOOL "Disables some build steps which are only relevant for releases to speed up compilation time for development")

#############################################################
if (APPLE)
  # QGIS custom dependencies package from qgis/QGIS-Mac-Packager
  # they can be downloaded from https://download.qgis.org/downloads/macos/deps/
  # and extracted to /opt/QGIS/qgis-deps-<deps-version>/stage
  set (QGIS_MAC_DEPS_DIR "" CACHE PATH "Path to QGIS Mac custom dependencies directory")

  # Setup LIB_DIR and CMAKE_PREFIX_PATH to help CMake's
  # find_packages to look for these libraries instead of system libraries
  if ( QGIS_MAC_DEPS_DIR )
    set(ENV{LIB_DIR} ${QGIS_MAC_DEPS_DIR})
    list(APPEND CMAKE_PREFIX_PATH ${QGIS_MAC_DEPS_DIR})
  endif()
endif()

#############################################################
# Configure OpenCL if available
set(HAVE_OPENCL FALSE)
if (${CMAKE_HOST_SYSTEM_NAME} MATCHES "BSD$")
  option(USE_OPENCL "Use OpenCL" OFF)
else()
  option(USE_OPENCL "Use OpenCL" ON)
endif()
if (USE_OPENCL)
    find_package(OpenCL)
    if(${OpenCL_FOUND})
        set(HAVE_OPENCL TRUE)
        # Fixup for standard FindOpenCL module not assigning proper framework headers directory
        if (APPLE AND "${OpenCL_INCLUDE_DIR}" MATCHES "OpenCL\\.framework/?$")
            set(OpenCL_INCLUDE_DIR "${OpenCL_INCLUDE_DIR}/Headers" CACHE PATH "" FORCE)
            set(OpenCL_INCLUDE_DIRS ${OpenCL_INCLUDE_DIR})
        endif()
        find_package(OpenCLhpp)
        if(NOT OPENCL_HPP_FOUND)
            # Use internal headers copied from OpenCL-CLHPP project
            set(OPENCL_HPP_INCLUDE_DIR ${CMAKE_SOURCE_DIR}/external/opencl-clhpp/include CACHE PATH "" FORCE)
            message(STATUS "Couldn't find OpenCL C++ headers, using internal: ${OPENCL_HPP_INCLUDE_DIR}")
        endif()
        set(OpenCL_INCLUDE_DIRS ${OpenCL_INCLUDE_DIRS} ${OPENCL_HPP_INCLUDE_DIR})
    else()
        message(STATUS "Couldn't find OpenCL: support DISABLED")
    endif()
endif()

# Configure CCache if available
option(USE_CCACHE "Use ccache" ON)
if (USE_CCACHE)
  find_program(CCACHE_FOUND ccache)
  if(CCACHE_FOUND)
    message(STATUS "ccache found")
    execute_process(COMMAND ccache --help OUTPUT_STRIP_TRAILING_WHITESPACE OUTPUT_VARIABLE CCACHE_HELP)
    execute_process(COMMAND ccache --get-config sloppiness OUTPUT_STRIP_TRAILING_WHITESPACE OUTPUT_VARIABLE CCACHE_SLOPPINESS)
    execute_process(COMMAND ccache --get-config compiler_type OUTPUT_STRIP_TRAILING_WHITESPACE OUTPUT_VARIABLE CCACHE_COMPILER_TYPE)
    string(FIND "${CCACHE_SLOPPINESS}" "pch_defines" fpch_defines_found_index)
    string(FIND "${CCACHE_SLOPPINESS}" "time_macros" time_macros_found_index)
    string(FIND "${CCACHE_SLOPPINESS}" "include_file_mtime" include_file_mtime_found_index)
    string(FIND "${CCACHE_SLOPPINESS}" "include_file_ctime" include_file_ctime_found_index)
    # Detect if we have ccache >= 4.8 which accepts passing configuration settings when invoking the compiler
    string(FIND "${CCACHE_HELP}" "ccache [KEY=VALUE ...] compiler" ccache_key_value_found_index)
    if (fpch_defines_found_index EQUAL -1 OR time_macros_found_index EQUAL -1 OR
        (BUILD_WITH_QT6 AND (include_file_mtime_found_index EQUAL -1 OR include_file_ctime_found_index EQUAL -1)))
        set(CCACHE_SLOPPINESS_REQUIRED "pch_defines,time_macros")
        if (BUILD_WITH_QT6 AND (include_file_mtime_found_index EQUAL -1 OR include_file_ctime_found_index EQUAL -1))
          string(APPEND CCACHE_SLOPPINESS_REQUIRED ",include_file_mtime,include_file_ctime")
        endif()
    else()
        set(CCACHE_SLOPPINESS_REQUIRED "")
    endif()
    if (BUILD_WITH_QT6 AND CMAKE_CXX_COMPILER STREQUAL "/usr/bin/c++" AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND NOT "${CCACHE_COMPILER_TYPE}" STREQUAL "gcc")
        # Cf https://github.com/ccache/ccache/discussions/959
        set(CCACHE_COMPILER_TYPE_GCC_REQUIRED ON)
    else()
        set(CCACHE_COMPILER_TYPE_GCC_REQUIRED OFF)
    endif()
    set(CCACHE_INVOCATION_COMMAND "ccache")
    if (MSVC)
       # CCache doesn't work yet with precompiled headers (cf https://github.com/ccache/ccache/issues/1383)
       # so no need to set specific ccache configuration items
    elseif (ccache_key_value_found_index EQUAL -1 )
      if (CCACHE_SLOPPINESS_REQUIRED)
          message(FATAL_ERROR "The use of precompiled headers only works if the ccache 'sloppiness' settings contains 'pch_defines' and 'time_macros'. Consider running 'ccache --set-config sloppiness=${CCACHE_SLOPPINESS_REQUIRED}' to define them")
      endif()
      if (CCACHE_COMPILER_TYPE_GCC_REQUIRED)
          message(FATAL_ERROR "The use of precompiled headers only works properly with QT6 if the ccache 'compiler_type' settings is set to 'gcc'. Consider running 'ccache --set-config compiler_type=gcc'")
      endif()
    else()
      if (CCACHE_SLOPPINESS_REQUIRED)
        string(APPEND CCACHE_INVOCATION_COMMAND " sloppiness=${CCACHE_SLOPPINESS_REQUIRED}")
      endif()
      if (CCACHE_COMPILER_TYPE_GCC_REQUIRED)
        string(APPEND CCACHE_INVOCATION_COMMAND " compiler_type=gcc")
      endif()
    endif()
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_INVOCATION_COMMAND}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK "${CCACHE_INVOCATION_COMMAND}")
  endif(CCACHE_FOUND)
endif(USE_CCACHE)

if (USE_CCACHE AND MSVC)
  # CCache doesn't work yet with precompiled headers (cf https://github.com/ccache/ccache/issues/1383)
  set(USE_PRECOMPILED_HEADERS OFF)
else()
  set(USE_PRECOMPILED_HEADERS ON)
endif()

if (IOS)
    set (DEFAULT_FORCE_STATIC_LIBS TRUE)
else()
    set (DEFAULT_FORCE_STATIC_LIBS FALSE)
endif()

set (FORCE_STATIC_LIBS ${DEFAULT_FORCE_STATIC_LIBS} CACHE BOOL "Determines whether libraries should be static only")
mark_as_advanced(FORCE_STATIC_LIBS)
if (FORCE_STATIC_LIBS)
  set (LIBRARY_TYPE STATIC)
  # following variable is used in qgsconfig.h
  set (HAVE_STATIC_PROVIDERS TRUE)
else()
  set (LIBRARY_TYPE SHARED)
  unset(HAVE_STATIC_PROVIDERS)
endif()

# in generated makefiles use relative paths so the project dir is moveable
# Note commented out since it cause problems but it would be nice to resolve these and enable
#
# issue is caused by include_directories(${CMAKE_BINARY_DIR}) near the end of this file generating incorrect path
#set (CMAKE_USE_RELATIVE_PATHS ON)

set (WITH_CORE TRUE CACHE BOOL "Determines whether QGIS core should be built.")
mark_as_advanced(WITH_CORE)

if(WITH_CORE)
  # Try to configure and build GRASS plugin by default
  foreach (GRASS_SEARCH_VERSION 7 8)
    # Legacy note:
    # For GRASS 6 there were used cached variables without version suffix so that existing caches didn't have to be reconfigured.
    # Cached variables were: WITH_GRASS, WITH_GRASS7, GRASS_PREFIX, GRASS_PREFIX7, GRASS_INCLUDE_DIR, GRASS_INCLUDE_DIR7
    # Everywhere else each variable has version major appended.
    # Normal variables were: GRASS_FOUND6, GRASS_FOUND7, GRASS_MAJOR_VERSION6, GRASS_MAJOR_VERSION7, etc.
    # In addition there is also GRASS_FOUND, which is TRUE if at least one version of GRASS was found
    set (GRASS_CACHE_VERSION ${GRASS_SEARCH_VERSION})
    set (WITH_GRASS${GRASS_CACHE_VERSION} TRUE CACHE BOOL "Determines whether GRASS ${GRASS_SEARCH_VERSION} plugin should be built")
    if (WITH_GRASS${GRASS_CACHE_VERSION})
      find_package(GRASS ${GRASS_SEARCH_VERSION})
      set (GRASS_PREFIX${GRASS_CACHE_VERSION} ${GRASS_PREFIX${GRASS_SEARCH_VERSION}} CACHE PATH "Path to GRASS ${GRASS_SEARCH_VERSION} base directory")
    endif()
  endforeach (GRASS_SEARCH_VERSION)


  set (WITH_OAUTH2_PLUGIN TRUE CACHE BOOL "Determines whether OAuth2 authentication method plugin should be built")
  if(WITH_OAUTH2_PLUGIN)
    set(HAVE_OAUTH2_PLUGIN TRUE)
  endif()

  set (WITH_AUTH TRUE CACHE BOOL "Determines whether QGIS authentication methods should be built")

  set (WITH_ANALYSIS TRUE CACHE BOOL "Determines whether QGIS analysis library should be built")

  if(WITH_DESKTOP)
      if((WIN32 AND NOT MINGW) OR (UNIX AND NOT APPLE AND NOT ANDROID AND NOT IOS))
	set (CRASH_HANDLER_AVAILABLE TRUE)
      else()
	set (CRASH_HANDLER_AVAILABLE FALSE)
      endif()

      set (WITH_CRASH_HANDLER ${CRASH_HANDLER_AVAILABLE} CACHE BOOL "Determines whether the QGIS crash handler application should be built")
      if(WITH_CRASH_HANDLER AND NOT CRASH_HANDLER_AVAILABLE)
	message(FATAL_ERROR "Crash handler cannot be built on this environment. Set WITH_CRASH_HANDLER to false.")
      endif()
      if(WITH_CRASH_HANDLER)
	set (HAVE_CRASH_HANDLER TRUE)    # used in qgsconfig.h
      else()
	set (HAVE_CRASH_HANDLER FALSE)    # used in qgsconfig.h
      endif()
  endif()

  set (WITH_QUICK FALSE CACHE BOOL "Determines whether QGIS Quick library should be built")

=== postinstall/CMakeLists.txt ===

# for included scripts that set policies
install (CODE "cmake_policy(SET CMP0011 NEW)")

if(MSVC AND NOT USING_NMAKE)
  set(CRSSYNC "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/crssync.exe")
else()
  set(CRSSYNC "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/crssync")
endif()

configure_file("PostInstall.cmake.in" "PostInstall.cmake" @ONLY)
install(SCRIPT "${CMAKE_BINARY_DIR}/postinstall/PostInstall.cmake")

=== src/analysis/CMakeLists.txt ===
#############################################################
# sources

BISON_TARGET(QgsRasterCalcParser raster/qgsrastercalcparser.yy ${CMAKE_CURRENT_BINARY_DIR}/qgsrastercalcparser.cpp COMPILE_FLAGS "-p raster_")
FLEX_TARGET(QgsRasterCalcLexer raster/qgsrastercalclexer.ll ${CMAKE_CURRENT_BINARY_DIR}/qgsrastercalclexer.cpp)
ADD_FLEX_BISON_DEPENDENCY(QgsRasterCalcLexer QgsRasterCalcParser)

set(QGIS_ANALYSIS_SRCS
  qgsanalysis.cpp


  ${FLEX_QgsRasterCalcLexer_OUTPUTS}
  ${BISON_QgsRasterCalcParser_OUTPUTS}

  georeferencing/qgsgcpgeometrytransformer.cpp
  georeferencing/qgsgcppoint.cpp
  georeferencing/qgsgcptransformer.cpp
  georeferencing/qgsleastsquares.cpp
  georeferencing/qgsvectorwarper.cpp

  interpolation/qgsgridfilewriter.cpp
  interpolation/qgsidwinterpolator.cpp
  interpolation/qgsinterpolator.cpp
  interpolation/qgstininterpolator.cpp
  interpolation/Bezier3D.cpp
  interpolation/CloughTocherInterpolator.cpp
  interpolation/qgsdualedgetriangulation.cpp
  interpolation/HalfEdge.cpp
  interpolation/LinTriangleInterpolator.cpp
  interpolation/MathUtils.cpp
  interpolation/NormVecDecorator.cpp
  interpolation/ParametricLine.cpp
  interpolation/TriangleInterpolator.cpp
  interpolation/qgstriangulation.cpp
  interpolation/TriDecorator.cpp
  interpolation/Vector3D.cpp

  processing/qgsalgorithmaddincrementalfield.cpp
  processing/qgsalgorithmaddtablefield.cpp
  processing/qgsalgorithmaddxyfields.cpp
  processing/qgsalgorithmaffinetransform.cpp
  processing/qgsalgorithmaggregate.cpp
  processing/qgsalgorithmalignrasters.cpp
  processing/qgsalgorithmalignsingleraster.cpp
  processing/qgsalgorithmangletonearest.cpp
  processing/qgsalgorithmannotations.cpp
  processing/qgsalgorithmapplylayerstyle.cpp
  processing/qgsalgorithmarraytranslatedfeatures.cpp
  processing/qgsalgorithmaspect.cpp
  processing/qgsalgorithmassignprojection.cpp
  processing/qgsalgorithmattributeindex.cpp
  processing/qgsalgorithmb3dmtogltf.cpp
  processing/qgsalgorithmbasicstatistics.cpp
  processing/qgsalgorithmbatchgeocode.cpp
  processing/qgsalgorithmbatchnominatimgeocode.cpp
  processing/qgsalgorithmboundary.cpp
  processing/qgsalgorithmboundingbox.cpp
  processing/qgsalgorithmbuffer.cpp
  processing/qgsalgorithmcalculateexpression.cpp
  processing/qgsalgorithmcalculateoverlaps.cpp
  processing/qgsalgorithmcategorizeusingstyle.cpp
  processing/qgsalgorithmcellstatistics.cpp
  processing/qgsalgorithmcentroid.cpp
  processing/qgsalgorithmcheckgeometrysegmentlength.cpp
  processing/qgsalgorithmcheckgeometryangle.cpp
  processing/qgsalgorithmcheckvalidity.cpp
  processing/qgsalgorithmfixgeometryduplicatenodes.cpp
  processing/qgsalgorithmfixgeometrymultipart.cpp
  processing/qgsalgorithmfixgeometryoverlap.cpp
  processing/qgsalgorithmfixgeometrydeletefeatures.cpp
  processing/qgsalgorithmfixgeometryangle.cpp
  processing/qgsalgorithmfixgeometryselfintersection.cpp
  processing/qgsalgorithmfixgeometrygap.cpp
  processing/qgsalgorithmcheckgeometryhole.cpp
  processing/qgsalgorithmfixgeometryhole.cpp
  processing/qgsalgorithmcheckgeometrymissingvertex.cpp
  processing/qgsalgorithmfixgeometrymissingvertex.cpp
  processing/qgsalgorithmcheckgeometryarea.cpp
  processing/qgsalgorithmfixgeometryarea.cpp
  processing/qgsalgorithmcheckgeometrylineintersection.cpp
  processing/qgsalgorithmcheckgeometrylinelayerintersection.cpp
  processing/qgsalgorithmcheckgeometrypointcoveredbyline.cpp
  processing/qgsalgorithmcheckgeometrypointinpolygon.cpp
  processing/qgsalgorithmcheckgeometrygap.cpp
  processing/qgsalgorithmcheckgeometrysliverpolygon.cpp
  processing/qgsalgorithmcheckgeometryselfcontact.cpp
  processing/qgsalgorithmcheckgeometryoverlap.cpp
  processing/qgsalgorithmcheckgeometryfollowboundaries.cpp
  processing/qgsalgorithmcheckgeometryduplicatenodes.cpp
  processing/qgsalgorithmcheckgeometrydangle.cpp
  processing/qgsalgorithmcheckgeometryduplicate.cpp
  processing/qgsalgorithmcheckgeometryselfintersection.cpp
  processing/qgsalgorithmcheckgeometrymultipart.cpp
  processing/qgsalgorithmcheckgeometrydegeneratepolygon.cpp
  processing/qgsalgorithmcheckgeometrycontained.cpp
  processing/qgsalgorithmclimb.cpp
  processing/qgsalgorithmclip.cpp
  processing/qgsalgorithmconcavehull.cpp
  processing/qgsalgorithmconcavehullbyfeature.cpp
  processing/qgsalgorithmconditionalbranch.cpp
  processing/qgsalgorithmconstantraster.cpp
  processing/qgsalgorithmconverttocurves.cpp
  processing/qgsalgorithmconvertgeometrytype.cpp
  processing/qgsalgorithmconvexhull.cpp
  processing/qgsalgorithmcoveragesimplify.cpp
  processing/qgsalgorithmcoverageunion.cpp
  processing/qgsalgorithmcoveragevalidate.cpp
  processing/qgsalgorithmcreatedirectory.cpp
  processing/qgsalgorithmdbscanclustering.cpp
  processing/qgsalgorithmdefineprojection.cpp
  processing/qgsalgorithmdelaunaytriangulation.cpp
  processing/qgsalgorithmdeleteduplicategeometries.cpp
  processing/qgsalgorithmdensifygeometriesbycount.cpp
  processing/qgsalgorithmdensifygeometriesbyinterval.cpp
  processing/qgsalgorithmdetectdatasetchanges.cpp
  processing/qgsalgorithmdifference.cpp
  processing/qgsalgorithmdissolve.cpp
  processing/qgsalgorithmdistancewithin.cpp
  processing/qgsalgorithmdownloadvectortiles.cpp
  processing/qgsalgorithmdrape.cpp
  processing/qgsalgorithmdropfields.cpp
  processing/qgsalgorithmdropgeometry.cpp
  processing/qgsalgorithmdropmzvalues.cpp
  processing/qgsalgorithmdxfexport.cpp
  processing/qgsalgorithmexecutepostgisquery.cpp
  processing/qgsalgorithmexecutespatialitequery.cpp
  processing/qgsalgorithmexecutespatialitequeryregistered.cpp
  processing/qgsalgorithmexplode.cpp
  processing/qgsalgorithmexplodehstore.cpp
  processing/qgsalgorithmexportgeometryattributes.cpp
  processing/qgsalgorithmexportlayersinformation.cpp
  processing/qgsalgorithmexportmesh.cpp
  processing/qgsalgorithmexporttopostgresql.cpp
  processing/qgsalgorithmexporttospreadsheet.cpp
  processing/qgsalgorithmextendlines.cpp
  processing/qgsalgorithmextentfromlayer.cpp
  processing/qgsalgorithmextenttolayer.cpp
  processing/qgsalgorithmextractbinary.cpp
  processing/qgsalgorithmextractbyattribute.cpp
  processing/qgsalgorithmextractbyexpression.cpp
  processing/qgsalgorithmextractbyextent.cpp
  processing/qgsalgorithmextractbylocation.cpp
  processing/qgsalgorithmextractlabels.cpp
  processing/qgsalgorithmextractlayoutmapextent.cpp
  processing/qgsalgorithmextractzmvalues.cpp
  processing/qgsalgorithmextractvertices.cpp
  processing/qgsalgorithmextractspecificvertices.cpp
  processing/qgsalgorithmfieldcalculator.cpp
  processing/qgsalgorithmfiledownloader.cpp
  processing/qgsalgorithmfillnodata.cpp
  processing/qgsalgorithmfillsinkswangliu.cpp
  processing/qgsalgorithmfilter.cpp
  processing/qgsalgorithmfilterbygeometry.cpp
  processing/qgsalgorithmfiltervertices.cpp
  processing/qgsalgorithmfindprojection.cpp
  processing/qgsalgorithmfixgeometries.cpp
  processing/qgsalgorithmflattenrelationships.cpp
  processing/qgsalgorithmforcerhr.cpp
  processing/qgsalgorithmfuzzifyraster.cpp
  processing/qgsalgorithmgenerateelevationprofile.cpp
  processing/qgsalgorithmgeometrybyexpression.cpp
  processing/qgsalgorithmgltftovector.cpp
  processing/qgsalgorithmgpsbabeltools.cpp
  processing/qgsalgorithmgrid.cpp
  processing/qgsalgorithmhillshade.cpp
  processing/qgsalgorithmimportphotos.cpp
  processing/qgsalgorithminterpolatepoint.cpp
  processing/qgsalgorithmintersection.cpp
  processing/qgsalgorithmjoinbyattribute.cpp
  processing/qgsalgorithmjoinbylocation.cpp
  processing/qgsalgorithmjoinbylocationsummary.cpp
  processing/qgsalgorithmjoinbynearest.cpp
  processing/qgsalgorithmjoinwithlines.cpp
  processing/qgsalgorithmkeepnbiggestparts.cpp
  processing/qgsalgorithmkmeansclustering.cpp
  processing/qgsalgorithmlayoutatlastoimage.cpp
  processing/qgsalgorithmlayoutatlastopdf.cpp
  processing/qgsalgorithmlayouttoimage.cpp
  processing/qgsalgorithmlayouttopdf.cpp
  processing/qgsalgorithmlinedensity.cpp
  processing/qgsalgorithmlineintersection.cpp
  processing/qgsalgorithmlinesubstring.cpp
  processing/qgsalgorithmloadlayer.cpp
  processing/qgsalgorithmmeancoordinates.cpp
  processing/qgsalgorithmmergelines.cpp
  processing/qgsalgorithmmeshsurfacetopolygon.cpp
  processing/qgsalgorithmmergevector.cpp
  processing/qgsalgorithmminimumenclosingcircle.cpp
  processing/qgsalgorithmmultidifference.cpp
  processing/qgsalgorithmmultiintersection.cpp
  processing/qgsalgorithmmultiparttosinglepart.cpp
  processing/qgsalgorithmmultiringconstantbuffer.cpp
  processing/qgsalgorithmmultiunion.cpp
  processing/qgsalgorithmnearestneighbouranalysis.cpp
  processing/qgsalgorithmoffsetlines.cpp
  processing/qgsalgorithmorderbyexpression.cpp
  processing/qgsalgorithmorientedminimumboundingbox.cpp
  processing/qgsalgorithmorthogonalize.cpp
  processing/qgsalgorithmpackage.cpp
  processing/qgsalgorithmpixelcentroidsfrompolygons.cpp
  processing/qgsalgorithmarrayoffsetlines.cpp
  processing/qgsalgorithmpolygonstolines.cpp
  processing/qgsalgorithmpointonsurface.cpp
  processing/qgsalgorithmpointsinpolygon.cpp
  processing/qgsalgorithmpointtolayer.cpp
  processing/qgsalgorithmpointsalonggeometry.cpp
  processing/qgsalgorithmpointslayerfromtable.cpp
  processing/qgsalgorithmpointstopaths.cpp
  processing/qgsalgorithmpoleofinaccessibility.cpp
  processing/qgsalgorithmpolygonize.cpp
  processing/qgsalgorithmprojectpointcartesian.cpp
  processing/qgsalgorithmpromotetomultipart.cpp
  processing/qgsalgorithmraiseexception.cpp
  processing/qgsalgorithmrandomextract.cpp
  processing/qgsalgorithmrandompointsextent.cpp
  processing/qgsalgorithmrandompointsinpolygons.cpp
  processing/qgsalgorithmrandompointsonlines.cpp
  processing/qgsalgorithmrandomraster.cpp
  processing/qgsalgorithmrastercalculator.cpp
  processing/qgsalgorithmrasterdtmslopebasedfilter.cpp
  processing/qgsalgorithmrasterfrequencybycomparisonoperator.cpp
  processing/qgsalgorithmrasterlayerproperties.cpp
  processing/qgsalgorithmrasterlayeruniquevalues.cpp
  processing/qgsalgorithmrasterlogicalop.cpp
  processing/qgsalgorithmrasterminmax.cpp
  processing/qgsalgorithmrasterize.cpp
  processing/qgsalgorithmrasterrank.cpp
  processing/qgsalgorithmrastersampling.cpp
  processing/qgsalgorithmrasterstackposition.cpp
  processing/qgsalgorithmrasterstatistics.cpp
  processing/qgsalgorithmrastersurfacevolume.cpp
  processing/qgsalgorithmrasterzonalstats.cpp
  processing/qgsalgorithmreclassifybylayer.cpp
  processing/qgsalgorithmrectanglesovalsdiamonds.cpp
  processing/qgsalgorithmrefactorfields.cpp
  processing/qgsalgorithmremoveduplicatesbyattribute.cpp
  processing/qgsalgorithmremoveduplicatevertices.cpp
  processing/qgsalgorithmremoveholes.cpp
  processing/qgsalgorithmremovenullgeometry.cpp
  processing/qgsalgorithmrenamelayer.cpp
  processing/qgsalgorithmrenametablefield.cpp
  processing/qgsalgorithmrepairshapefile.cpp
  processing/qgsalgorithmrescaleraster.cpp
  processing/qgsalgorithmreverselinedirection.cpp
  processing/qgsalgorithmrotate.cpp
  processing/qgsalgorithmroundness.cpp
  processing/qgsalgorithmroundrastervalues.cpp
  processing/qgsalgorithmruggedness.cpp
  processing/qgsalgorithmsavefeatures.cpp
  processing/qgsalgorithmsavelog.cpp
  processing/qgsalgorithmsaveselectedfeatures.cpp
  processing/qgsalgorithmsegmentize.cpp
  processing/qgsalgorithmserviceareafromlayer.cpp
  processing/qgsalgorithmserviceareafrompoint.cpp
  processing/qgsalgorithmsetlayerencoding.cpp
  processing/qgsalgorithmsetmvalue.cpp
  processing/qgsalgorithmsetvariable.cpp
  processing/qgsalgorithmsetzvalue.cpp
  processing/qgsalgorithmshortestline.cpp
  processing/qgsalgorithmshortestpathlayertopoint.cpp
  processing/qgsalgorithmshortestpathpointtolayer.cpp
  processing/qgsalgorithmshortestpathpointtopoint.cpp
  processing/qgsalgorithmshpencodinginfo.cpp
  processing/qgsalgorithmsimplify.cpp
  processing/qgsalgorithmsinglesidedbuffer.cpp
  processing/qgsalgorithmslope.cpp
  processing/qgsalgorithmsmooth.cpp
  processing/qgsalgorithmsnapgeometries.cpp

=== src/plugins/topology/CMakeLists.txt ===

########################################################
# Files

set (topol_SRCS
  topol.cpp
  rulesDialog.cpp
  checkDock.cpp
  topolError.cpp
  topolTest.cpp
  dockModel.cpp
)

set (topol_UIS
  rulesDialog.ui
  checkDock.ui
)

set (topol_RCCS  topol.qrc)

########################################################
# Build

qt_wrap_ui(topol_UIS_H  ${topol_UIS})

add_library (plugin_topology MODULE ${topol_SRCS} ${topol_RCCS} ${topol_UIS_H})

# require c++17
target_compile_features(plugin_topology PRIVATE cxx_std_17)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/plugins

  ${CMAKE_BINARY_DIR}/src/ui
  ${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries(plugin_topology
  qgis_core
  qgis_gui
)


########################################################
# Install

install(TARGETS plugin_topology
  RUNTIME DESTINATION ${QGIS_PLUGIN_DIR}
  LIBRARY DESTINATION ${QGIS_PLUGIN_DIR})

=== src/providers/grass/CMakeLists.txt ===
#add_definitions(-DGRASS_BASE="${GRASS_PREFIX}")
########################################################
# Build

include_directories(

  ${CMAKE_BINARY_DIR}/src/providers/grass
  ${CMAKE_CURRENT_BINARY_DIR}
)
include_directories (SYSTEM
  ${POSTGRES_INCLUDE_DIR}
)

#
# GRASS library
#
macro(ADD_GRASSLIB GRASS_BUILD_VERSION)
    set(GRASS_PREFIX ${GRASS_PREFIX${GRASS_BUILD_VERSION}})
    set(GRASS_MAJOR_VERSION ${GRASS_MAJOR_VERSION${GRASS_BUILD_VERSION}})
    set(GRASS_MINOR_VERSION ${GRASS_MINOR_VERSION${GRASS_BUILD_VERSION}})
    set(GRASS_OFF_T_SIZE ${GRASS_OFF_T_SIZE${GRASS_BUILD_VERSION}})

    set (GRASS_LIBRARY_SRCS
      ../qgsgrass.cpp
      ../qgsgrasswin.cpp
      ../qgsgrassdatafile.cpp
      ../qgsgrassfeatureiterator.cpp
      ../qgsgrassimport.cpp
      ../qgsgrassprovider.cpp
      ../qgsgrassrasterprovider.cpp
      ../qgsgrassundocommand.cpp
      ../qgsgrassvector.cpp
      ../qgsgrassvectormap.cpp
      ../qgsgrassvectormaplayer.cpp
    )

    if (WITH_GUI)
      set(GRASS_LIBRARY_SRCS ${GRASS_LIBRARY_SRCS}
        ../qgsgrassoptions.cpp
      )
    endif()

    if(MSVC)
      # 4611 setjmp
      set_source_files_properties(
        ../qgsgrassimport.cpp
        ../qgsgrassprovider.cpp
        ../qgsgrassvector.cpp
        ../qgsgrassvectormap.cpp
        ../qgsgrassvectormaplayer.cpp
        PROPERTIES COMPILE_FLAGS "-wd4611"
      )

      # 4611 setjmp
      # 4702 unreachable code
      set_source_files_properties(
        ../qgsgrass.cpp
        PROPERTIES COMPILE_FLAGS "-wd4611 -wd4702"
      )
    endif()

    qt_wrap_ui(GRASS_LIBRARY_UIS_H ../qgsgrassoptionsbase.ui)

    add_library(qgisgrass${GRASS_BUILD_VERSION} SHARED
      ${GRASS_LIBRARY_SRCS}
      ${GRASS_LIBRARY_UIS_H}
    )

    # require c++17
    target_compile_features(qgisgrass${GRASS_BUILD_VERSION} PRIVATE cxx_std_17)

    if(GRASS_OFF_T_SIZE)
      set(GRASS_OFF_T_SIZE_DEF "\"-DGRASS_OFF_T_SIZE=${GRASS_OFF_T_SIZE}\"")
    else()
      set(GRASS_OFF_T_SIZE_DEF "")
    endif()

    if(QGIS_MACAPP_FRAMEWORK)
      set_target_properties(qgisgrass${GRASS_BUILD_VERSION} PROPERTIES
        CLEAN_DIRECT_OUTPUT 1
        FRAMEWORK 1
        FRAMEWORK_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}"
        MACOSX_FRAMEWORK_INFO_PLIST "${CMAKE_SOURCE_DIR}/mac/framework.info.plist.in"
        MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${COMPLETE_VERSION}
        MACOSX_FRAMEWORK_IDENTIFIER org.qgis.qgis3_grass
        COMPILE_FLAGS "-DGRASS_BASE=\\\"${GRASS_PREFIX}\\\" ${GRASS_OFF_T_SIZE_DEF}"
      )
    else()
        set_target_properties(qgisgrass${GRASS_BUILD_VERSION} PROPERTIES
        CLEAN_DIRECT_OUTPUT 1
        FRAMEWORK 0
        COMPILE_FLAGS "-DGRASS_BASE=\\\"${GRASS_PREFIX}\\\" ${GRASS_OFF_T_SIZE_DEF}"
      )
    endif()

    if (APPLE)
      set_target_properties(qgisgrass${GRASS_BUILD_VERSION} PROPERTIES
        LINK_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}"
        )
    endif()

    #generate unversioned libs for android
    if (NOT ANDROID)
      set_target_properties(qgisgrass${GRASS_BUILD_VERSION} PROPERTIES
        VERSION ${COMPLETE_VERSION}
        SOVERSION ${COMPLETE_VERSION}
      )
    endif()

    if (GRASS_MAJOR_VERSION LESS 7 )
      set(GRASS_TARGET_LINK_LIBRARIES${GRASS_BUILD_VERSION}
          qgis_core
          ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gis}
          ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_vect}
          ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_I}
          ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_dbmibase}
          ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_dbmiclient}
          ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gproj}
	  GDAL::GDAL
      )
    else()
      set(GRASS_TARGET_LINK_LIBRARIES${GRASS_BUILD_VERSION}
        qgis_core
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gis}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_vector}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_raster}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_imagery}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_dbmibase}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_dbmiclient}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gproj}
	GDAL::GDAL
      )
    endif()

    target_link_libraries(qgisgrass${GRASS_BUILD_VERSION} ${GRASS_TARGET_LINK_LIBRARIES${GRASS_BUILD_VERSION}})
	  if(WITH_POSTGRESQL)
	    target_link_libraries(qgisgrass${GRASS_BUILD_VERSION} PostgreSQL::PostgreSQL)
	  endif()

    if (WITH_GUI)
      target_link_libraries(qgisgrass${GRASS_BUILD_VERSION}
        qgis_gui
      )
    endif()

    if (APPLE)
      set_target_properties(qgisgrass${GRASS_BUILD_VERSION} PROPERTIES BUILD_WITH_INSTALL_RPATH TRUE)
    endif()

    GENERATE_EXPORT_HEADER(
       qgisgrass${GRASS_BUILD_VERSION}
       BASE_NAME GRASS_LIB
       EXPORT_FILE_NAME qgis_grass_lib.h
    )

    #
    # GRASS vector provider
    #
    set (GRASS_VECTOR_PROVIDER_SRCS ../qgsgrassprovidermodule.cpp)
    add_library(provider_grass${GRASS_BUILD_VERSION} MODULE ${GRASS_VECTOR_PROVIDER_SRCS})

    # require c++17
    target_compile_features(provider_grass${GRASS_BUILD_VERSION} PRIVATE cxx_std_17)

    set_target_properties(provider_grass${GRASS_BUILD_VERSION} PROPERTIES
      COMPILE_FLAGS "-DGRASS_BASE=\\\"${GRASS_PREFIX}\\\""
    )
    target_link_libraries(provider_grass${GRASS_BUILD_VERSION}
      qgisgrass${GRASS_BUILD_VERSION}
    )

    if (WITH_GUI)
      target_link_libraries(provider_grass${GRASS_BUILD_VERSION}
        qgis_gui
      )
      add_dependencies(provider_grass${GRASS_BUILD_VERSION} ui)
    endif()

    #
    # grass raster provider
    #
    set (GRASS_RASTER_PROVIDER_SRCS
      ../qgsgrassrasterprovidermodule.cpp
    )
    add_library(provider_grassraster${GRASS_BUILD_VERSION} MODULE ${GRASS_RASTER_PROVIDER_SRCS})

    # require c++17
    target_compile_features(provider_grassraster${GRASS_BUILD_VERSION} PRIVATE cxx_std_17)

    set_target_properties(provider_grassraster${GRASS_BUILD_VERSION} PROPERTIES
      COMPILE_FLAGS "-DGRASS_BASE=\\\"${GRASS_PREFIX}\\\""
    )
    target_link_libraries(provider_grassraster${GRASS_BUILD_VERSION}
      qgisgrass${GRASS_BUILD_VERSION}
      qgis_core
    )

    # override default path where built files are put to allow running qgis without installing
    # the modules go under libexec subdir
    set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${QGIS_OUTPUT_DIRECTORY}/${QGIS_LIBEXEC_SUBDIR}/grass/modules)

    #
    # grass raster display module
    #
    add_executable(qgis.d.rast${GRASS_BUILD_VERSION} ../qgis.d.rast.c)
    if (GRASS_MAJOR_VERSION LESS 7 )
      target_link_libraries(qgis.d.rast${GRASS_BUILD_VERSION}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gis}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_datetime}
        GDAL::GDAL
      )
    else()
      target_link_libraries(qgis.d.rast${GRASS_BUILD_VERSION}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gis}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_datetime}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_raster}
        GDAL::GDAL
      )
    endif()

    #
    # grass info module
    #
    add_executable(qgis.g.info${GRASS_BUILD_VERSION} ../qgis.g.info.c)
    if (GRASS_MAJOR_VERSION LESS 7 )
      target_link_libraries(qgis.g.info${GRASS_BUILD_VERSION}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gis}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_datetime}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gproj}
        GDAL::GDAL
      )
    else()
      target_link_libraries(qgis.g.info${GRASS_BUILD_VERSION}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gis}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_datetime}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gproj}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_raster}
        GDAL::GDAL
      )
    endif()
    if (UNIX)
      target_link_libraries(qgis.g.info${GRASS_BUILD_VERSION} m)
    endif()

    #
    # grass raster import module
    #
    add_executable(qgis.r.in${GRASS_BUILD_VERSION} ../qgis.r.in.cpp)
    set_target_properties(qgis.r.in${GRASS_BUILD_VERSION} PROPERTIES
      COMPILE_FLAGS "-DGRASS_BASE=\\\"${GRASS_PREFIX}\\\""
    )
    if (GRASS_MAJOR_VERSION LESS 7 )
      target_link_libraries(qgis.r.in${GRASS_BUILD_VERSION}
        qgisgrass${GRASS_BUILD_VERSION}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gis}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_datetime}
        GDAL::GDAL
        qgis_core
      )
    else()
      target_link_libraries(qgis.r.in${GRASS_BUILD_VERSION}
        qgisgrass${GRASS_BUILD_VERSION}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gis}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_datetime}
        ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_raster}
        GDAL::GDAL
        qgis_core
      )
    endif()

    #
    # grass vector import module
    #
    add_executable(qgis.v.in${GRASS_BUILD_VERSION} ../qgis.v.in.cpp)
    set_target_properties(qgis.v.in${GRASS_BUILD_VERSION} PROPERTIES
      COMPILE_FLAGS "-DGRASS_BASE=\\\"${GRASS_PREFIX}\\\""
    )
    target_link_libraries(qgis.v.in${GRASS_BUILD_VERSION}
      qgisgrass${GRASS_BUILD_VERSION}
      ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_gis}
      ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_datetime}
      ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_vect}
      ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_dbmibase}
      ${GRASS_LIBRARY${GRASS_BUILD_VERSION}_dbmiclient}
      GDAL::GDAL
      qgis_core
    )

    ########################################################
    # Install

    install(TARGETS qgisgrass${GRASS_BUILD_VERSION}
      RUNTIME DESTINATION ${QGIS_BIN_DIR}
      LIBRARY DESTINATION ${QGIS_LIB_DIR}
      FRAMEWORK DESTINATION ${QGIS_FW_SUBDIR})

    install(TARGETS provider_grass${GRASS_BUILD_VERSION}
      RUNTIME DESTINATION ${QGIS_PLUGIN_DIR}
      LIBRARY DESTINATION ${QGIS_PLUGIN_DIR})

    install(TARGETS provider_grassraster${GRASS_BUILD_VERSION}
      RUNTIME DESTINATION ${QGIS_PLUGIN_DIR}
      LIBRARY DESTINATION ${QGIS_PLUGIN_DIR})

    install(TARGETS
      qgis.d.rast${GRASS_BUILD_VERSION}
      qgis.g.info${GRASS_BUILD_VERSION}
      qgis.r.in${GRASS_BUILD_VERSION}
      qgis.v.in${GRASS_BUILD_VERSION}
      RUNTIME DESTINATION ${QGIS_LIBEXEC_DIR}/grass/modules
      PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
    )
endmacro(ADD_GRASSLIB)

foreach(GRASS_BUILD_VERSION 6 7 8)
  if(GRASS_FOUND${GRASS_BUILD_VERSION})
    add_subdirectory(${GRASS_BUILD_VERSION})
  endif()
endforeach(GRASS_BUILD_VERSION)

#
# Fake GRASS gis library
#
set(WITH_GRASS_DIRECT FALSE) # currently disabled

if(WITH_GRASS_DIRECT)
  # only process functions if qgsgrassgislibfunctions.cpp/h not present
  # or gisdefs.h is newer

  if("${GRASS_INCLUDE_DIR}/grass/gisdefs.h" IS_NEWER_THAN "${CMAKE_CURRENT_BINARY_DIR}/qgsgrassgislibfunctions.cpp" OR "${GRASS_INCLUDE_DIR}/grass/gisdefs.h" IS_NEWER_THAN "${CMAKE_CURRENT_BINARY_DIR}/qgsgrassgislibfunctions.h")

  # Generate function mapping for functions used in original version
  # Create list of functions to be mapped
  set ( FUNCTIONS
    "G_add_color_rule"
    "G_add_c_raster_color_rule"
    "G_add_d_raster_color_rule"
    "G_add_f_raster_color_rule"
    "G_add_modular_color_rule"
    "G_add_raster_color_rule"
    "G_adjust_Cell_head"
    "G_adjust_easting"
    "G_adjust_east_longitude"
    "G_align_window"
    "G__allocate_null_bits"
    "G_allocate_cell_buf"
    "G_allocate_c_raster_buf"
    "G_allocate_d_raster_buf"
    "G_allocate_f_raster_buf"
    "G_allocate_null_buf"
    "G_allocate_raster_buf"
    "G_ask_any"
    "G_ask_in_mapset"
    "G_ask_new"
    "G_ask_old"
    "G__calloc"
    "G_chop"
    "G_chrcat"
    "G_chrcpy"
    "G_chrmov"
    "G_colors_count"
    "G_col_to_easting"
    "G_convert_dirseps_to_host"
    "G_copy"
    "G_copy_file"
    "G_create_key_value"
    "G_database_projection_name"
    "G_date"
    "G_define_flag"
    "G_define_module"
    "G_define_option"
    "G_define_standard_option"
    "G_easting_to_col"
    "G_find_key_value"
    "G_find_cell_stat"
    "G_fopen_new"
    "G_format_easting"
    "G_format_northing"

=== debian/changelog ===
qgis (3.44.1) UNRELEASED; urgency=medium

  * Release of 3.44.1

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 18 Jul 2025 14:02:24 +0200

qgis (3.44.0) unstable; urgency=medium

  * Release of 3.44.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 18 Jul 2025 14:02:24 +0200

qgis (3.43.0) unstable; urgency=medium

  * New development version 3.43 after branch of 3.42

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 20 Jun 2025 14:08:50 +0200

qgis (3.40.4) unstable; urgency=medium

  * Release of 3.40.4

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 21 Feb 2025 14:15:07 +0100

qgis (3.40.3) unstable; urgency=medium

  * Release of 3.40.3

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 21 Feb 2025 14:12:41 +0100

qgis (3.40.2) unstable; urgency=medium

  * Release of 3.40.2

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 17 Jan 2025 13:02:24 +0100

qgis (3.40.1) unstable; urgency=medium

  * Release of 3.40.1

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 20 Dec 2024 13:00:48 +0100

qgis (3.40.0) unstable; urgency=medium

  * Release of 3.40.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 22 Nov 2024 13:07:29 +0100

qgis (3.39.0) unstable; urgency=medium

  * New development version 3.39 after branch of 3.38

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 25 Oct 2024 14:08:45 +0200

qgis (3.38.0) unstable; urgency=medium

  * Release of 3.38.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 21 Jun 2024 14:04:59 +0200

qgis (3.37.0) unstable; urgency=medium

  * New development version 3.37 after branch of 3.36

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 21 Jun 2024 14:02:23 +0200

qgis (3.36.0) unstable; urgency=medium

  * Release of 3.36.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 23 Feb 2024 13:06:57 +0100

qgis (3.35.0) unstable; urgency=medium

  * New development version 3.35 after branch of 3.34

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 23 Feb 2024 13:04:10 +0100

qgis (3.34.0) unstable; urgency=medium

  * Release of 3.34.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 27 Oct 2023 14:05:40 +0200

qgis (3.33.0) unstable; urgency=medium

  * New development version 3.33 after branch of 3.32

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 27 Oct 2023 14:02:22 +0200

qgis (3.32.0) unstable; urgency=medium

  * Release of 3.32.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 23 Jun 2023 14:42:17 +0200

qgis (3.31.0) unstable; urgency=medium

  * New development version 3.31 after branch of 3.30

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 23 Jun 2023 14:40:51 +0200

qgis (3.30.0) unstable; urgency=medium

  * Release of 3.30.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 03 Mar 2023 20:27:19 +0100

qgis (3.29.0) unstable; urgency=medium

  * New development version 3.29 after branch of 3.28

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 03 Mar 2023 20:25:40 +0100

qgis (3.28.0) unstable; urgency=medium

  * Release of 3.28.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 21 Oct 2022 14:14:19 +0200

qgis (3.27.0) unstable; urgency=medium

  * New development version 3.27 after branch of 3.26

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 21 Oct 2022 14:11:09 +0200

qgis (3.26.0) unstable; urgency=medium

  * Release of 3.26.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 17 Jun 2022 14:08:26 +0200

qgis (3.25.0) unstable; urgency=medium

  * New development version 3.25 after branch of 3.24

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 17 Jun 2022 14:05:27 +0200

qgis (3.24.0) unstable; urgency=medium

  * Release of 3.24.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 18 Feb 2022 13:08:40 +0100

qgis (3.23.0) unstable; urgency=medium

  * New development version 3.23 after branch of 3.22

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 18 Feb 2022 13:06:09 +0100

qgis (3.22.0) unstable; urgency=medium

  * Release of 3.22.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 22 Oct 2021 14:15:20 +0200

qgis (3.21.0) unstable; urgency=medium

  * New development version 3.21 after branch of 3.20

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 22 Oct 2021 14:12:10 +0200

qgis (3.20.0) unstable; urgency=medium

  * Release of 3.20.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 18 Jun 2021 14:12:46 +0200

qgis (3.19.0) unstable; urgency=medium

  * New development version 3.19 after branch of 3.18

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 18 Jun 2021 14:10:08 +0200

qgis (3.18.0) unstable; urgency=medium

  * Release of 3.18.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 19 Feb 2021 13:12:08 +0100

qgis (3.17.0) unstable; urgency=medium

  * New development version 3.17 after branch of 3.16

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 19 Feb 2021 13:09:46 +0100

qgis (3.16.0) unstable; urgency=medium

  * Release of 3.16.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 23 Oct 2020 14:12:56 +0200

qgis (3.15.0) unstable; urgency=medium

  * New development version 3.15 after branch of 3.14

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 23 Oct 2020 14:10:17 +0200

qgis (3.14.0) unstable; urgency=medium

  * Release of 3.14.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 19 Jun 2020 14:17:00 +0200

qgis (3.13.0) unstable; urgency=medium

  * New development version 3.13 after branch of 3.12

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 19 Jun 2020 14:15:52 +0200

qgis (3.12.0) unstable; urgency=medium

  * Release of 3.12.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 21 Feb 2020 13:38:01 +0100

qgis (3.11.0) unstable; urgency=medium

  * New development version 3.11 after branch of 3.10

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 21 Feb 2020 13:36:42 +0100

qgis (3.10.0) unstable; urgency=medium

  * Release of 3.10.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 25 Oct 2019 14:15:55 +0200

qgis (3.9.0) unstable; urgency=medium

  * New development version 3.9 after branch of 3.8

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 25 Oct 2019 14:14:52 +0200

qgis (3.8.0) unstable; urgency=medium

  * Release of 3.8.0

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 21 Jun 2019 14:33:27 +0200

qgis (3.7.0) unstable; urgency=medium



=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qgis
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.44.1
pkgrel=1
pkgdesc='Geographic Information System (GIS) that supports vector, raster & database formats (mingw-w64)'
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://qgis.org/'
msys2_repository_url="https://github.com/qgis/QGIS"
msys2_references=(
  'archlinux: qgis'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-draco"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-gdal"
         "${MINGW_PACKAGE_PREFIX}-geos"
         "${MINGW_PACKAGE_PREFIX}-gsl"
         "${MINGW_PACKAGE_PREFIX}-exiv2"
         "${MINGW_PACKAGE_PREFIX}-libspatialite"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-libzip"
         "${MINGW_PACKAGE_PREFIX}-opencl-icd"
         "${MINGW_PACKAGE_PREFIX}-pdal"
         "${MINGW_PACKAGE_PREFIX}-proj"
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-python-gdal"
         "${MINGW_PACKAGE_PREFIX}-python-jinja"
         "${MINGW_PACKAGE_PREFIX}-python-owslib"
         "${MINGW_PACKAGE_PREFIX}-python-pyqt5"
         "${MINGW_PACKAGE_PREFIX}-python-qscintilla-qt5"
         "${MINGW_PACKAGE_PREFIX}-qca-qt5"
         "${MINGW_PACKAGE_PREFIX}-qt5-3d"
         "${MINGW_PACKAGE_PREFIX}-qt5-base"
         "${MINGW_PACKAGE_PREFIX}-qt5-declarative"
         "${MINGW_PACKAGE_PREFIX}-qt5-location"
         "${MINGW_PACKAGE_PREFIX}-qt5-multimedia"
         "${MINGW_PACKAGE_PREFIX}-qt5-serialport"
         "${MINGW_PACKAGE_PREFIX}-qt5-svg"
         "${MINGW_PACKAGE_PREFIX}-qt5-tools"
         "${MINGW_PACKAGE_PREFIX}-qtkeychain-qt5"
         "${MINGW_PACKAGE_PREFIX}-qscintilla-qt5"
         "${MINGW_PACKAGE_PREFIX}-qwt-qt5"
         "${MINGW_PACKAGE_PREFIX}-sqlite3"
         "${MINGW_PACKAGE_PREFIX}-spatialindex"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zstd")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-nlohmann-json"
             "${MINGW_PACKAGE_PREFIX}-opencl-clhpp"
             "${MINGW_PACKAGE_PREFIX}-sip"
             "${MINGW_PACKAGE_PREFIX}-pyqt-builder"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-netcdf"
             "${MINGW_PACKAGE_PREFIX}-postgresql")
#optdepends=("${MINGW_PACKAGE_PREFIX}-netcdf: mdal plugin"
#            "${MINGW_PACKAGE_PREFIX}-postgresql: postgres plugins")
source=("https://qgis.org/downloads/${_realname}-$pkgver.tar.bz2"
        "001-fix-building-with-mingw-w64-clang.patch"
        "002-fix-settingstree-init-order-clang.patch"
        "003-fix-build-with-qt5-and-pdal.patch"
        "004-fix-customwidgets-install.patch")
sha256sums=('b228ef7093da0e9f7a594b93a57ef737cdefd8c07b84ccff251da1f7d2bb6f4b'
            '82d8839992f08a26ea7caf5e908e5f4111806df211ae5cec91e2b86e49b43e75'
            '47e6471b92b85d97e58b617da326c15622c01786c19eb7d4d5814483becb75e4'
            'bbd476f619ebd7ed8e4acb0c6a3be9b0356cd37267d7ecbeb53aea372b91207b'
            '216dc67ef707f2e918afb7d190c9ea75c11065dea0d23d11b94cab5d8463bac3')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    apply_patch_with_msg \
      001-fix-building-with-mingw-w64-clang.patch \
      002-fix-settingstree-init-order-clang.patch
  fi
  apply_patch_with_msg \
    003-fix-build-with-qt5-and-pdal.patch \
    004-fix-customwidgets-install.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    CXXFLAGS+=" -Wno-ignored-attributes"
  else
    CXXFLAGS+=" -Wno-attributes"
  fi
  CXXFLAGS+=" -Wno-deprecated-declarations"

  LDFLAGS+=" -Wl,--stack,8388608" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_CXX_STANDARD=17 \
    "${_extra_config[@]}" \
    -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    -DQGIS_BIN_SUBDIR=bin \
    -DQGIS_DATA_SUBDIR=share \
    -DQGIS_LIBEXEC_SUBDIR=bin \
    -DQGIS_PLUGIN_SUBDIR=lib/qgis/plugins \
    -DQT_PLUGINS_DIR=share/qt5/plugins \
    -DPREFER_INTERNAL_LIBS=OFF \
    -DWITH_INTERNAL_POLY2TRI=ON \
    -DWITH_INTERNAL_MESHOPTIMIZER=ON \
    -DWITH_INTERNAL_NLOHMANN_JSON=OFF \
    -DWITH_3D=ON \
    -DWITH_BINDINGS=ON \
    -DWITH_CUSTOM_WIDGETS=ON \
    -DWITH_EPT=ON \
    -DWITH_PDAL=ON \
    -DWITH_POSTGRESQL=ON \
    -DWITH_QTWEBKIT=OFF \
    -DWITH_QUICK=ON \
    -DWITH_QWTPOLAR=ON \
    -DENABLE_TESTS=OFF \
    -DWITH_GRASS=OFF \
    -DPEDANTIC=OFF \
    ../${_realname}-$pkgver

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-$pkgver/COPYING \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
